Subject: RE: bug#16483: 24.3.50; `read-face-name' is a mess now (regression)

From: Drew Adams <[email-masked]>
Date: Fri, 29 Apr 2016 11:09:35 -0700 (PDT)

> > 1. The doc string no longer says what the behavior is if DEFAULT is nil.
> > In Emacs 24.3, it said this for that case:
> >
> >  If DEFAULT is nil, the list of default face names is taken from
> >  the `read-face-name' property of the text at point, or, if that
> >  is nil, from the `face' property of the text at point.
> >
> > What happens now?  No information about that.  See below for my guess.
> > Please tell users of the function what its behavior is.
> 
> As far as I can see, if DEFAULT is nil, there is no list of default face
> names?

Yes, and so no default value is put in the prompt.

Note: This handling of the prompt and the default value(s) for
this function have a long and torturous history.  This stuff
has been changed a zillion times, with each time being something
arcane and incomprehensible for users (IMHO).

It is simpler (better) now.  This item (#1) can be closed: if
DEFAULT is nil now, the only effect it has is on the return
value (`nil'). 

> > 2. The doc string says that DEFAULT is returned if the user enters the
> > empty string.  That is clearly wrong, at least when DEFAULT is a list of
> > faces or face names.  DEFAULT is not returned in such cases.  The most
> > that can be said in general is that DEFAULT _determines_ what is
> > returned for empty input - not that DEFAULT _is_ what is returned.
> 
> I've now made the doc string more correct, if more difficult to parse.

I trust it must be better.  It can always be improved more
in the future if not completely satisfactory.  Thx.

> > 8. What happened to the useful defaulting of previous Emacs versions?
> > Yes, I know why you made the change, but now any existing code that uses
> > `read-face-name' is broken if it depends on `r-f-n' to provide such
> > defaulting.  Too bad.
> >
> > Please consider: There is more Elisp code in the world than just what is
> > distributed by Emacs Dev.  `read-face-name' has been and continues to be
> > a poster child of how not to evolve code.  It has morphed in incompatible
> > ways from version to version.  The right way to do what you wanted to do
> > for Emacs 24.4 would have been to go ahead and define `face-at-point',
> > but to *use* it in `read-face-name', so that that function continues to
> > provide the expected defaulting when DEFAULT is nil:
> >
> >   (unless default (setq default  (face-at-point)))
> >
> > I somehow doubt that that part of the regression will be fixed, but
> > perhaps some of the other points above have a chance of being addressed.
> 
> Yes, that's outside the scope of read-face-name, I think.